
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class VaccinationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const vaccinations = await db.vaccinations.create(
            {
                id: data.id || undefined,
        
        vaccine_name: data.vaccine_name
        ||
        null
            ,
            
        vaccine_code: data.vaccine_code
        ||
        null
            ,
            
        recommended_min_age_days: data.recommended_min_age_days
        ||
        null
            ,
            
        recommended_max_age_days: data.recommended_max_age_days
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await vaccinations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return vaccinations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const vaccinationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                vaccine_name: item.vaccine_name
            ||
            null
            ,
            
                vaccine_code: item.vaccine_code
            ||
            null
            ,
            
                recommended_min_age_days: item.recommended_min_age_days
            ||
            null
            ,
            
                recommended_max_age_days: item.recommended_max_age_days
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const vaccinations = await db.vaccinations.bulkCreate(vaccinationsData, { transaction });

        // For each item created, replace relation files
        

        return vaccinations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const vaccinations = await db.vaccinations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.vaccine_name !== undefined) updatePayload.vaccine_name = data.vaccine_name;
        
        
        if (data.vaccine_code !== undefined) updatePayload.vaccine_code = data.vaccine_code;
        
        
        if (data.recommended_min_age_days !== undefined) updatePayload.recommended_min_age_days = data.recommended_min_age_days;
        
        
        if (data.recommended_max_age_days !== undefined) updatePayload.recommended_max_age_days = data.recommended_max_age_days;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await vaccinations.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await vaccinations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return vaccinations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const vaccinations = await db.vaccinations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of vaccinations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of vaccinations) {
                await record.destroy({transaction});
            }
        });


        return vaccinations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const vaccinations = await db.vaccinations.findByPk(id, options);

        await vaccinations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await vaccinations.destroy({
            transaction
        });

        return vaccinations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const vaccinations = await db.vaccinations.findOne(
            { where },
            { transaction },
        );

        if (!vaccinations) {
            return vaccinations;
        }

        const output = vaccinations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.patient_vaccinations_vaccination = await vaccinations.getPatient_vaccinations_vaccination({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.organizations = await vaccinations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.vaccine_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'vaccinations',
                        'vaccine_name',
                        filter.vaccine_name,
                    ),
                };
            }
            
            if (filter.vaccine_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'vaccinations',
                        'vaccine_code',
                        filter.vaccine_code,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'vaccinations',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.recommended_min_age_daysRange) {
                const [start, end] = filter.recommended_min_age_daysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    recommended_min_age_days: {
                    ...where.recommended_min_age_days,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    recommended_min_age_days: {
                    ...where.recommended_min_age_days,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.recommended_max_age_daysRange) {
                const [start, end] = filter.recommended_max_age_daysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    recommended_max_age_days: {
                    ...where.recommended_max_age_days,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    recommended_max_age_days: {
                    ...where.recommended_max_age_days,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.vaccinations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'vaccinations',
                        'vaccine_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.vaccinations.findAll({
            attributes: [ 'id', 'vaccine_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['vaccine_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.vaccine_name,
        }));
    }

    
};

